RequireScript("httpclient.js");

function HttpServer()
{
	this.port = 80;
	this.log = OpenLog("http.log");
	this.pending_socket = false;
	
	this.tag = "Server (0.0.2b)";
	this.default_index = ["index.jhtml", "index.html"];
	this.clients = [];
	
	this.running = true;
	
	this.run = function()
	{
		if (!this.pending_socket)
		{
			this.pending_socket = ListenOnPort(this.port);
		}
			
		while (this.running)
		{
			if (this.pending_socket.isConnected())
			{
				this.log.write("Received a new connection.");
				this.clients.push(new HttpClient(this.pending_socket, this));
				this.pending_socket = ListenOnPort(this.port);
			}
			
			var finished = [];
			
			for (var i = 0; i < this.clients.length; i++)
			{
				this.clients[i].update();
				if (this.clients[i].finished)
				{
					this.log.write("Client " + i + " is finished.");
					finished.push(i);
				}
			}
			var off = 0;
			for (var i = 0; i < finished.length; i++)
			{
				this.clients.splice(finished[i] + off, 1);
				off--;
			}
		}
	}
}